package com.company.sample.config;

import com.haulmont.cuba.core.global.Events;
import com.haulmont.cuba.core.sys.events.AppContextInitializedEvent;
import com.haulmont.cuba.core.sys.listener.EntityListenerManager;
import com.haulmont.cuba.security.entity.UserRole;
import org.springframework.context.event.EventListener;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

/**
 * Класс для регистрации листенера сущности UserRole.
 */
@Component("example_EntityListenersInitializer")
public class EntityListenersInitializer {

    private EntityListenerManager entityListenerManager;

    public EntityListenersInitializer(final EntityListenerManager entityListenerManager) {
        this.entityListenerManager = entityListenerManager;
    }

    @EventListener(AppContextInitializedEvent.class)
    @Order(Events.LOWEST_PLATFORM_PRECEDENCE + 100)
    public void initializeUserRoleEntityListener() {
        this.entityListenerManager.addListener(UserRole.class, "example_UserRoleEntityListener");
    }
}
