package com.company.sample.listeners;

import com.company.sample.service.UseFlowableSampleService;
import com.haulmont.cuba.core.listener.AfterInsertEntityListener;
import com.haulmont.cuba.security.entity.UserRole;
import org.springframework.stereotype.Component;
import org.springframework.transaction.support.TransactionSynchronizationAdapter;
import org.springframework.transaction.support.TransactionSynchronizationManager;

import java.sql.Connection;

/**
 * Листенер, в котором вызывается сервис с логикой взаимодействия с BProc.
 */
@Component("example_UserRoleEntityListener")
public class UserRoleEntityListener implements AfterInsertEntityListener<UserRole> {

    private UseFlowableSampleService exampleService;

    public UserRoleEntityListener(final UseFlowableSampleService exampleService) {
        this.exampleService = exampleService;
    }

    @Override
    public void onAfterInsert(final UserRole entity, final Connection connection) {
        TransactionSynchronizationManager.registerSynchronization(
                new TransactionSynchronizationAdapter() {
                    @Override
                    public void afterCommit() {
                        exampleService.exampleVoid();
                    }
                }
        );
    }
}
